=== debian/changelog ===
debian-reference (2.33) unstable; urgency=low

  * More Japanese translation up to 5.8.
  * Fixed bugs in English while translating.
  * Updated chroot section.
  * Changed Makefile to use msgmerge. 
  * Asciidoc conversion is done in lenny before build by
    "make xml".  No more need to depend on asciidoc.

 -- Osamu Aoki <osamu@debian.org>  Sat, 27 Jun 2009 00:36:05 +0900

debian-reference (2.32) unstable; urgency=low

  * Fixed DDP build script to function well.
  * More Japanese translation up to 2.7.7.
  * Used .SECONDAY to keep XML files in source. 

 -- Osamu Aoki <osamu@debian.org>  Sat, 06 Jun 2009 03:29:52 +0900

debian-reference (2.31) unstable; urgency=low

  * Switched English source format to asciidoc and reorganized the
    whole source tree.  No more MoinMoin support.
  * Created po4a based translation infrastructure.
  * Supported offical DDP web site pages to be build.
  * Started new translation for Japanese (partial).
  * Moved source from alioth GIT back to DDP SVN which was at 1.09-3.
  * Added new icon for debian-reference.

 -- Osamu Aoki <osamu@debian.org>  Sun, 17 May 2009 09:31:45 +0900

debian-reference (2.30) unstable; urgency=low

  * Updated MoinMoin access methods to match the server upgrade. 
  * Updated few contents from Wiki.
  * Fixed incorrect advice about $PATH for sudo per  Sven Joachim. 
    Closes: 525868.

 -- Osamu Aoki <osamu@debian.org>  Wed, 29 Apr 2009 11:41:14 +0900

debian-reference (2.29) unstable; urgency=low

  * Refined per general suggestions of Tim Richardson.
  * Expanded "Conventions".
  * Updated popcon and package size data.

 -- Osamu Aoki <osamu@debian.org>  Mon, 16 Feb 2009 22:54:41 +0900

debian-reference (2.28) unstable; urgency=low

  * Updated non-English documents for removed xmove package 

 -- Osamu Aoki <osamu@debian.org>  Mon, 09 Feb 2009 21:35:13 +0900

debian-reference (2.27) unstable; urgency=low

  * Updated for removed packages: xmove, iceape-browser, es
  * Updated popcon and package size data. 

 -- Osamu Aoki <osamu@debian.org>  Sun, 08 Feb 2009 18:05:17 +0900

debian-reference (2.26) unstable; urgency=low

  * Fixed around "fair use" in "Copyright history".
  * Commened on solution to DNS timeout for exim4.

 -- Osamu Aoki <osamu@debian.org>  Tue, 03 Feb 2009 00:02:55 +0900

debian-reference (2.25) unstable; urgency=low

  * Added "Automatic download and upgrade of packages", "Limit download
    bandwidth for APT", description for dump package and many external URL
    links.
  * Fixed typos and many style inconsistencies.

 -- Osamu Aoki <osamu@debian.org>  Sat, 31 Jan 2009 08:07:27 +0900
